var Encoder = require('../encoder');
var Decoder = require('../decoder');
var crc32 = require('buffer-crc32');

var msg = {
    service: crc32.unsigned("Container.Common.Ping"),
    flag: 8,
    time: Math.ceil(+new Date() / 1000),
    uniqid: 1,
    askId: 1,
    code: 6000,
    routers: 2,
    dstMode: 1,
    routersList: [new Buffer(8), new Buffer(8)],
    dstParam: new Buffer(8)
};

var body = {
    name: 'UnitTest'
};

var decoder = new Decoder();
var encoder = new Encoder();
var buffer = encoder.encode(body, msg);

console.time("decoder 1w");
for (var i = 0; i < 10000; i++) {
    decoder.decode(buffer);
}
console.timeEnd("decoder 1w");

console.time("decoder 10w");
for (var i = 0; i < 100000; i++) {
    decoder.decode(buffer);
}
console.timeEnd("decoder 10w");

console.time("decoder 100w");
for (var i = 0; i < 1000000; i++) {
    decoder.decode(buffer);
}
console.timeEnd("decoder 100w");