var Encoder = require('../encoder');
var crc32 = require('buffer-crc32');

var msg = {
    service: crc32.unsigned("Container.Common.Ping"),
    flag: 8,
    time: Math.ceil(+new Date() / 1000),
    uniqid: 1,
    askId: 1,
    code: 6000,
    routers: 2,
    dstMode: 1,
    routersList: [new Buffer(8), new Buffer(8)],
    dstParam: new Buffer(8)
};

var body = {
    name: 'UnitTest'
};

var encoder = new Encoder();

console.time("encoder 1w");
for (var i = 0; i < 10000; i++) {
    encoder.encode(body, msg);
}
console.timeEnd("encoder 1w");

console.time("encoder 10w");
for (var i = 0; i < 100000; i++) {
    encoder.encode(body, msg);
}
console.timeEnd("encoder 10w");

console.time("encoder 100w");
for (var i = 0; i < 1000000; i++) {
    encoder.encode(body, msg);
}
console.timeEnd("encoder 100w");
