var Buffer = require('buffer').Buffer;
var _ = require('underscore');

var DEFAULT_HEADER_LEN = 22;
var DEFAULT_MSG = {
    packetLen: 0,
    headerLen: 0,
    flag: 0, // 发送事件时=2
    service: 0,
    time: 0,
    uniqid: 0,
    askId: 0,
    code: 0,
    routers: 0,
    dstMode: 0,
    routersList: [],
    dstParam: 0
};

function Encoder() {
    // nonthing need to code
}

Encoder.prototype.encode = function (body, msg) {
    msg = _.extend({}, DEFAULT_MSG, msg);
    var headerLen = DEFAULT_HEADER_LEN;
    if (msg.dstMode > 0) {
        headerLen += 8;
    }

    if (msg.routers > 0) {
        headerLen += (8 * msg.routers);
    }

    if(!Buffer.isBuffer(body)){
        body = body ? JSON.stringify(body) : '';
    }

    var packetLen = headerLen + 2;
    packetLen += body ? Buffer.byteLength(body) : 0;

    var offset = 0;
    var buffer = new Buffer(packetLen + 4);
    buffer.writeUInt32BE(packetLen, offset);
    buffer.writeUInt16BE(headerLen, offset += 4);
    buffer.writeUInt16BE(msg.flag, offset += 2);
    buffer.writeUInt32BE(msg.service, offset += 2);
    buffer.writeUInt32BE(msg.time, offset += 4);
    buffer.writeUInt32BE(msg.uniqid, offset += 4);
    buffer.writeUInt32BE(msg.askId, offset += 4);
    buffer.writeUInt16BE(msg.code, offset += 4);
    buffer.writeUInt8(msg.routers, offset += 2);
    buffer.writeUInt8(msg.dstMode, offset += 1);
    offset += 1;

    if (msg.routers > 0) {
        for (var i = 0, len = msg.routers; i < len; i++) {
            msg.routersList[i].copy(buffer, offset);
            offset += 8
        }
    }

    if (msg.dstMode > 0) {
        msg.dstParam.copy(buffer, offset);
        offset += 8
    }

    if (body) {
        if(Buffer.isBuffer(body)){
            buffer = buffer.slice(0,offset);
            buffer = Buffer.concat([buffer,body]);
        }else{
            buffer.write(body, offset);
        }
    }

    return buffer;
};

module.exports = Encoder;