var assert = require("assert");
var _ = require('underscore');
var crc32 = require('buffer-crc32');
var Buffer = require('buffer').Buffer;
var Encoder = require('../fpc').Encoder;

describe("Encoder", function () {
    it('encode method', function () {
        var msg = {
            service: crc32.unsigned("Container.Common.Ping"),
            flag: 8,
            time: Math.ceil(+new Date() / 1000),
            uniqid: 1,
            askId: 1,
            code: 6000,
            routers: 2,
            dstMode: 1,
            routersList: [new Buffer(8), new Buffer(8)],
            dstParam: new Buffer(8),
            body: {
                name: 'UnitTest'
            }
        };

        var encoder = new Encoder();
        var buffer = encoder.encode(msg.body, _.omit(msg, 'body'));

        var packetLen = buffer.readUInt32BE();
        var headerLen = buffer.readUInt16BE(4);
        var bodyLen = packetLen - headerLen - 2;
        var start = headerLen + 6;
        var json = JSON.parse(buffer.slice(start, start + bodyLen).toString());
        assert.deepEqual(json, msg.body);
    });
});