var assert = require('assert');
var Server = require('../fpc').Server;
var crc32 = require('buffer-crc32');


var SERVICE_HOST = '172.16.90.42';
var SERVICE_PORT = 9900;

var noop = function () {
    // something to do...
};

describe('Server', function () {
    var index = 0;
    var serviceName = '';
    this.timeout(5 * 1000);

    beforeEach(function () {
        serviceName = 'unit_test_' + (index++);
    });

    it('connect', function (done) {
        var server = new Server(SERVICE_HOST, SERVICE_PORT, serviceName);
        server.on('connect', function () {
            done();
        });
    });

    it('register', function (done) {
        var server = new Server(SERVICE_HOST, SERVICE_PORT, serviceName);
        server.on('connect', function () {
            server.register();
        });
        server.on('register', function () {
            done();
        });
    });

    it('addHandler', function (done) {
        var server = new Server(SERVICE_HOST, SERVICE_PORT, serviceName);
        server.addHandler(serviceName, function () {
            // something to do...
        });

        server.on('connect', function () {
            server.register();
        });

        server.on('register', function () {
            done();
        });
    });

    it('removeHandler', function () {
        var crc32Name = crc32.unsigned(serviceName);
        var server = new Server(SERVICE_HOST, SERVICE_PORT, serviceName);
        server.addHandler(serviceName, noop);
        server.removeHandler(serviceName, noop);
        assert.equal(server.accepts[serviceName], null);
        assert.equal(server.acceptMap[crc32Name], null);
    });
});